VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "GetPath Setup"
   ClientHeight    =   3075
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3630
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3075
   ScaleWidth      =   3630
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkShow 
      Caption         =   "Show Confirmation when copying"
      Enabled         =   0   'False
      Height          =   225
      Left            =   90
      TabIndex        =   5
      Top             =   2235
      Width           =   3435
   End
   Begin VB.CommandButton btnAbout 
      Caption         =   "&About"
      Height          =   345
      Left            =   2655
      TabIndex        =   2
      Top             =   2625
      Width           =   885
   End
   Begin VB.CommandButton btnExit 
      Caption         =   "&Exit"
      Height          =   345
      Left            =   1373
      TabIndex        =   0
      Top             =   2625
      Width           =   885
   End
   Begin VB.CommandButton btnEnable 
      Caption         =   "Inte&grate"
      Height          =   345
      Left            =   105
      TabIndex        =   1
      Top             =   2625
      Width           =   885
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Center
      Caption         =   "ProgPath is already enabled"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   225
      Left            =   45
      TabIndex        =   4
      Top             =   1875
      Width           =   3510
   End
   Begin VB.Label lblExplain 
      Alignment       =   2  'Center
      Caption         =   "Explanations go here (see Form_Load)"
      Height          =   1455
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   3420
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function GetModuleHandle Lib "kernel32" _
    Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
    
Private Declare Function GetModuleFileName Lib "kernel32" _
    Alias "GetModuleFileNameA" (ByVal hModule As Long, _
    ByVal lpFileName As String, ByVal nSize As Long) As Long
    
Private Function InitLaunch()

' We display the form to allow user to setup the program
frmMain.Visible = True

' We shortly explain what is the program for in the label
lblExplain.Caption = "GetPath will add the new command" + vbCrLf + vbCrLf + _
    "'Copy Full Path to Clipboard'" + vbCrLf + vbCrLf + _
    "to the menu that pops up when" + vbCrLf + _
    "you right-click on a File or a Folder"

' We read the registry to setup the program
' (Registry code is in modRegistry.bas)
' We retrieve the Registry keys values. The empty string in the command
' will retrieve the default value
RegFile = GetStringKey(HKEY_CLASSES_ROOT, "*\shell\GetPath\command", "")
RegFolder = GetStringKey(HKEY_CLASSES_ROOT, "Folder\shell\GetPath\command", "")

' We check the File and Folder keys and test if the command is equal to
' the program location.
If Len(RegFile) > 5 Then
    If UCase(Left(RegFile, Len(RegFile) - 5)) = UCase(ProgPath + App.EXEName + ".exe") Then
        IsFile = True
    Else
        IsFile = False
    End If
Else
    IsFile = False
End If

If Len(RegFolder) > 5 Then
    If UCase(Left(RegFolder, Len(RegFolder) - 5)) = UCase(ProgPath + App.EXEName + ".exe") Then
        IsFolder = True
    Else
        IsFolder = False
    End If
Else
    IsFolder = False
End If
        
' If the 2 Keys are found in the registry (and if each Key contains the path to
' GetPath.exe), then GetPath is fully integrated in Windows shell.
' Also, we only enable the 'Show confirmation' checkbox if GetPath is
' integrated
If IsFile = True And IsFolder = True Then
    lblStatus.Caption = "GetPath is integrated to shell"
    lblStatus.ForeColor = RGB(0, 0, 255)
    btnEnable.Enabled = False '(no needs to register, GetPath is already in registry)
    chkShow.Enabled = True
Else
    lblStatus.Caption = "GetPath is not integrated to shell"
    lblStatus.ForeColor = RGB(255, 0, 0)
    btnEnable.Enabled = True '(GetPath can be registered in registry)
End If
        
End Function

Private Function CopyPath()

' Because we integrated GetPath.exe to the Windows shell,
' the command line (command$) will content the file or folder
' full Path. We only have to copy it to clipboard (after we
' removed the quotes (") if any
FoundPath = Command$
If Left$(FoundPath, 1) = Chr$(34) Then FoundPath = Right$(FoundPath, Len(FoundPath) - 1)
If Right$(FoundPath, 1) = Chr$(34) Then FoundPath = Left$(FoundPath, Len(FoundPath) - 1)
VB.Clipboard.Clear
VB.Clipboard.SetText FoundPath

' Then we play a "beep" to confirm to user copy is done
Beep

' We show the Confirmation form (unless user decided we don't)
If ShowForm = True Then frmShow.Show vbModal

' And we close GetPath
End
End Function

Private Sub btnAbout_Click()
frmAbout.Show vbModal
End Sub

Private Sub btnExit_Click()
' We store the decision of user to show or not the confirmation form
' (in Registry)
If chkShow.Value = 0 Then
    SetStringKey HKEY_CURRENT_USER, "Software\GetPath", "Show", "No"
Else
    SetStringKey HKEY_CURRENT_USER, "Software\GetPath", "Show", "Yes"
End If
End
End Sub

Private Sub btnEnable_Click()
Dim RegFile As String
Dim RegFolder As String
Dim Launcher As String

' We set Key values to be added in the registry as : X:\Path\GetPath.exe "%L"
' And we also set the menu title (Copy Full Path to Clipboard)
Launcher = ProgPath + App.EXEName + ".exe" + " " + Chr$(34) + "%L" + Chr$(34)
' for Files
SetStringKey HKEY_CLASSES_ROOT, "*\shell\GetPath", , "Copy Full Path to ClipBoard"
SetStringKey HKEY_CLASSES_ROOT, "*\shell\GetPath\command", , Launcher
' for Folders
SetStringKey HKEY_CLASSES_ROOT, "Folder\shell\GetPath", , "Copy Full Path to ClipBoard"
SetStringKey HKEY_CLASSES_ROOT, "Folder\shell\GetPath\command", , Launcher

' And we allow user to decide if he wants the Confirmation form displayed
chkShow.Enabled = True
Call Form_Load
End Sub

Private Sub Form_Load()
Dim lHandle As Long
Dim lresult As Long
Dim sBuffer As String

' This code will replace the App.Path statement because App.Path doesn't work
' from a removable media (ie CDROM) or over networks. It uses the API calls to
' GetModuleHandle and GetModuleFileName
sBuffer = Space$(MAX_PATH)
lHandle = GetModuleHandle(App.EXEName)
lresult = GetModuleFileName(lHandle, sBuffer, MAX_PATH)
tmpPath = sBuffer
For I = Len(tmpPath) To 1 Step -1
If Mid(tmpPath, I, 1) = "\" Then
    ProgPath = Left(tmpPath, I)
    Exit For
End If
Next I
' The main problem with this App.path replacement is it doesn't work
' when we are in the editor (it returns the vb editor location).
' So we test if GetPath.exe is in the returned folder. If not, then
' we are in the VB Editor, and we use the App.Path
If Not FileExists(ProgPath + App.EXEName) Then ProgPath = App.Path
' And finally, we add a backslash to ProgPath if there is not already
If Right(ProgPath, 1) <> "\" Then ProgPath = ProgPath + "\"

' We check registry to know if the user want the confirmation form to be
' displayed (We set this in the InitLaunch function or in the frmShow form)
If GetStringKey(HKEY_CURRENT_USER, "Software\GetPath", "Show") = "No" Then
    ShowForm = False
    chkShow.Value = 0 ' unchecked
Else
    ShowForm = True
    chkShow.Value = 1 ' checked
End If

' If program is launched as standalone, then we display the form
' (we call the function InitLaunch), else we copy full path
' to clipboard (we call function CopyPath)
If Len(Command$) = 0 Then
    InitLaunch
Else
    CopyPath
End If

End Sub
