Attribute VB_Name = "modRegistry2"
' (C) John McKee

Public SysRoot As String

'Private Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long

'*******************Registry Access********************************************
'Functions here from ADVAPI32.DLL

Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
'Private Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, lValueLen As Long) As Long
'Private Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long           ' Note that if you declare the lpData parameter as String, you must pass it By Value.
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long         ' Note that if you declare the lpData parameter as String, you must pass it By Value.

Private Type SECURITY_ATTRIBUTES
        nLength As Long
        lpSecurityDescriptor As Long
        bInheritHandle As Long
End Type


Public Enum APIRegistryRoots
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_CURRENT_USER = &H80000001
    HKEY_DYN_DATA = &H80000006
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_USERS = &H80000003
End Enum

'*********Reg. Value Types*********
Private Const REG_NONE = 0                       ' No value type
Private Const REG_SZ = 1                         ' Unicode nul terminated string
Private Const REG_EXPAND_SZ = 2                  ' Unicode nul terminated string
Private Const REG_BINARY = 3                     ' Free form binary
Private Const REG_DWORD = 4                      ' 32-bit number
Private Const REG_DWORD_LITTLE_ENDIAN = 4        ' 32-bit number (same as REG_DWORD)
Private Const REG_DWORD_BIG_ENDIAN = 5           ' 32-bit number
Private Const REG_LINK = 6                       ' Symbolic Link (unicode)
Private Const REG_MULTI_SZ = 7                   ' Multiple Unicode strings
Private Const REG_RESOURCE_LIST = 8              ' Resource list in the resource map
Private Const REG_FULL_RESOURCE_DESCRIPTOR = 9   ' Resource list in the hardware description
Private Const REG_RESOURCE_REQUIREMENTS_LIST = 10

Public Enum APIRegistryValueTypes
    NoType = REG_NONE   ' No value type
    StringType = REG_SZ ' Unicode nul terminated string
    ExpandedStringType = REG_EXPAND_SZ  ' Unicode nul terminated string
    BinaryType = REG_BINARY ' Free form binary
    DwordType = REG_DWORD ' 32-bit number
End Enum

'***********************************

Private Const ERROR_SUCCESS = 0

Private Const KEY_ALL_ACCESS = 983103


Private Const regErrOpenKey = 1
Private Const regErrQueryKey = 2
Private Const regErrCreateKey = 3
Private Const regErrSetKey = 4

Function GetStringKey(ByVal hKey As APIRegistryRoots, ByVal SubKey As String, Optional ByVal ValueName As String = "") As String
    Dim lRes As Long, lRetLen As Long, sRetVal As String
    Dim lHandle As Long
    lRes = RegOpenKey(hKey, SubKey, lHandle)
    If lRes <> ERROR_SUCCESS Then
        'Oops
        'Err.Raise vbObjectError + regErrOpenKey, "GetStringKey", "Win 32 API function failed to open registry key '" & SubKey & "'."
        Exit Function
    Else
        lRetLen = 400
        sRetVal = Space(lRetLen)
        lRes = RegQueryValueEx(lHandle, ValueName, 0, REG_SZ, ByVal sRetVal, lRetLen)
        If lRes <> ERROR_SUCCESS Then
            'Oops
            'Err.Raise vbObjectError + regErrQueryKey, "GetStringKey", "Win32 API function failed to get registry key value: '" & SubKey & "'."
            RegCloseKey lHandle
            Exit Function
        Else
            'OK...
            sRetVal = IIf(InStr(sRetVal, Chr(0)) <> 0, Left(sRetVal, InStr(sRetVal, Chr(0)) - 1), RTrim(sRetVal))
        End If
        RegCloseKey lHandle
    End If
    GetStringKey = sRetVal
End Function

Sub SetStringKey(ByVal hKey As APIRegistryRoots, ByVal SubKey As String, Optional ByVal ValueName As String = "", Optional ByVal Setting As String = "")
    Dim hNewHandle&, lpdwDisposition&, Temp As SECURITY_ATTRIBUTES
    If RegCreateKeyEx(hKey, SubKey, 0, ValueName, 0, KEY_ALL_ACCESS, Temp, hNewHandle, lpdwDisposition) = ERROR_SUCCESS Then
        If RegSetValueEx(hNewHandle, ValueName, 0, REG_SZ, ByVal Setting, Len(Setting)) <> ERROR_SUCCESS Then
            Err.Raise vbObjectError + regErrSetKey, "SetStringKey", "Win32 API function failed to set key value: '" & SubKey & "'."
            Exit Sub
        End If
    Else
        Err.Raise vbObjectError + regErrCreateKey, "SetStringKey", "Win32 API function failed to create key: '" & SubKey & "'."
        Exit Sub
    End If
    RegCloseKey hNewHandle
End Sub

